/***************************************************************************

  file.h

  The file management routines

  (c) 2000-2004 Benot Minisini <gambas@users.sourceforge.net>

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 1, or (at your option)
  any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

***************************************************************************/

#ifndef __GB_FILE_H
#define __GB_FILE_H

#include <sys/time.h>

PUBLIC char *FILE_cat(const char *path, ...);
PUBLIC int FILE_buffer_length(void);
PUBLIC char *FILE_get_dir(const char *path);
PUBLIC char *FILE_get_ext(const char *path);
PUBLIC char *FILE_get_current_dir(void);
PUBLIC char *FILE_set_ext(const char *path, const char *ext);
PUBLIC boolean FILE_exist(const char *path);
PUBLIC time_t FILE_get_time(const char *path);
PUBLIC char *FILE_get_name(const char *path);
PUBLIC const char *FILE_get_basename(const char *path);
PUBLIC char *FILE_readlink(const char *link);

#ifndef __GB_FILE_C
extern char *FILE_buffer;
#endif

#endif
