/***************************************************************************

  CNet.c

  Network component

  (c) 2003-2004 Daniel Campos Fern�dez <danielcampos@netcourrier.com>

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 1, or (at your option)
  any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

***************************************************************************/

#define __CNET_C
#include "main.h"
#include <stdio.h>

#include "CNet.h"

/***************************************************************
 Here we declare the public interface of NetCode class
 ***************************************************************/
GB_DESC CNetDesc[] =
{

  GB_DECLARE("Net", 0), GB_VIRTUAL_CLASS(),

  /* normal operation */
  GB_CONSTANT("Inactive", "i", 0),
  GB_CONSTANT("Active", "i", 1),
  GB_CONSTANT("Pending", "i", 2),
  GB_CONSTANT("Accepting","i",3),
  GB_CONSTANT("ReceivingData","i",4),
  GB_CONSTANT("Searching", "i", 5),
  GB_CONSTANT("Connecting", "i", 6),
  GB_CONSTANT("Connected", "i", 7),
  /* net error codes */
  GB_CONSTANT("CannotCreateSocket", "i", -2),
  GB_CONSTANT("ConnectionRefused", "i", -3),
  GB_CONSTANT("CannotRead", "i", -4),
  GB_CONSTANT("CannotWrite", "i", -5),
  GB_CONSTANT("HostNotFound", "i", -6),
  GB_CONSTANT("CannotBindSocket", "i", -10),
  GB_CONSTANT("CannotListen", "i", -14),
  /* SeverSocket, type */
  GB_CONSTANT("Internet", "i", 1),
  GB_CONSTANT("Local", "i", 0),
  GB_CONSTANT("Unix", "i", 0),
  
  GB_END_DECLARE
};




