/***************************************************************************

  CHttpClient.h

  Advanced Network component

  (c) 2003-2004 Daniel Campos Fernández <danielcampos@netcourrier.com>

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 1, or (at your option)
  any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

***************************************************************************/
#ifndef __CHTTPCLIENT_H
#define __CHTTPCLIENT_H

#include "gambas.h"
#include "gbcurl.h"
#include "CProxy.h"
#include <curl/curl.h>
#include <curl/easy.h>

#ifndef __CHTTPCLIENT_C


extern GB_DESC CHttpClientDesc[];
extern GB_STREAM_DESC HttpStream;

#else

#define THIS ((CHTTPCLIENT *)_object)

#endif

typedef  struct
{
	GB_BASE ob;
	GB_STREAM stream;
	CURL *curlhandle;

	int iStatus;

	char *sURL;
	int auth;

	char *cookiesfile;
	int updatecookies;

	char *sContentType;
	char *sPostData;
	int iMethod; // 0->Get, 0->Post
	char *sUserAgent;

	int len_data;
	char *buf_data;
	char **buf_header;
	int len_header;

	int   ReturnCode;
	char *ReturnString;

	FILE      *c_file;
	CPROXY    *proxy;
	Adv_user   user;

}  CHTTPCLIENT;

/*****/
void http_raise_finished(long lParam);
void http_raise_error(long lParam);
void http_raise_connect(long lParam);
void http_raise_read(long lParam);
/*****/
int http_find_info (CURL *curlfind);
/*****/
int http_header_curl(void *buffer, size_t size, size_t nmemb, void *c_handle);
int http_write_curl(void *buffer, size_t size, size_t nmemb, void *c_handle);
/*****/
void http_parse_header(CHTTPCLIENT *mythis);
/*****/
void http_reset(CHTTPCLIENT *mythis);
void http_stop(CHTTPCLIENT *mythis);
/*****/
//
void CHttp_stream_init(GB_STREAM *stream,int fd);
int  CHttp_stream_read(GB_STREAM *stream, char *buffer, long len);
int  CHttp_stream_write(GB_STREAM *stream, char *buffer, long len);
int  CHttp_stream_eof(GB_STREAM *stream);
int  CHttp_stream_lof(GB_STREAM *stream, long *len);
int  CHttp_stream_open(GB_STREAM *stream, const char *path, int mode, void *data);
int  CHttp_stream_seek(GB_STREAM *stream, long pos, int whence);
int  CHttp_stream_tell(GB_STREAM *stream, long *pos);
int  CHttp_stream_flush(GB_STREAM *stream);
int  CHttp_stream_close(GB_STREAM *stream);

#define HTTP_PROPERTIES "URL=127.0.0.1:80,User,Password,Auth=0,CookiesFile,UpdateCookies=FALSE,UserAgent=Gambas Http/1.0"
#endif
