/***************************************************************************

  vb.c

  Visual Basic compatibility Component

  (c) 2000-2003 Benoît Minisini <gambas@users.sourceforge.net>

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 1, or (at your option)
  any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with this program; if not, write to the Free Software
  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

***************************************************************************/

#define __VB_C

#include "vb.h"

BEGIN_METHOD(CVB_val, GB_STRING str)

  GB_VALUE result;

  GB.NumberFromString(GB_NB_READ_BOTH | GB_NB_READ_HEX_BIN, STRING(str), LENGTH(str), &result);

  if (result.type == GB_T_INTEGER)
    GB.ReturnInteger(((GB_INTEGER *)&result)->value);
  else if (result.type == GB_T_FLOAT)
    GB.ReturnFloat(((GB_FLOAT *)&result)->value);
  else
    GB.ReturnInteger(0);

END_METHOD


/* val should be GB_VARIANT. This is just a trick, so that
   I can use STRING() and LENGTH() macros just after having
   converted val to a string. Yes, I know... Horrible.
*/

BEGIN_METHOD(CVB_str, GB_STRING val)

  GB.Conv((GB_VALUE *)ARG(val), GB_T_STRING);

  GB.ReturnNewString(STRING(val), LENGTH(val));

END_METHOD

BEGIN_METHOD(CVB_Left, GB_STRING val;GB_INTEGER Count;)

  if (VARG(Count)<=0)
  {
  	GB.Error("Invalid parameter");
	return;
  }
  if ( LENGTH(val)<=VARG(Count) )
  {
  	GB.ReturnNewString(STRING(val), LENGTH(val));
	return;	
  }
  
  GB.ReturnNewString(STRING(val), VARG(Count));

END_METHOD

BEGIN_METHOD(CVB_Right, GB_STRING val;GB_INTEGER Count;)

  if (VARG(Count)<=0)
  {
  	GB.Error("Invalid parameter");
	return;
  }
  if ( LENGTH(val)<=VARG(Count) )
  {
  	GB.ReturnNewString(STRING(val), LENGTH(val));
	return;	
  }
  
  GB.ReturnNewString(STRING(val)+(LENGTH(val)-VARG(Count)), VARG(Count));

END_METHOD

BEGIN_METHOD(CVB_Mid, GB_STRING val;GB_INTEGER Start;GB_INTEGER Count;)

  int count;
   
  if (VARG(Count)<=0)
  {
  	GB.Error("Invalid parameter");
	return;
  }
  
  if (!MISSING (Count) )
  {
  	if (VARG(Count)<=0)
	{
		GB.Error("Invalid parameter");
		return;
	}
	count=VARG(Count);
  }
  else
  	count=LENGTH(val);
	
  if ( VARG(Start)>LENGTH(val) )
  	GB.ReturnNewString(NULL,0);
   
  if ( ( LENGTH(val)-VARG(Start) ) <=   count ) count=LENGTH(val)-VARG(Start)+1;

  GB.ReturnNewString(STRING(val)+VARG(Start)-1, count );
  

END_METHOD

GB_DESC CVbDesc[] =
{
  GB_DECLARE("Vb", 0), GB_NOT_CREATABLE(),

  GB_STATIC_METHOD("Val", "v", CVB_val, "(String)s"),
  GB_STATIC_METHOD("Str", "s", CVB_str, "(Value)v"),
  GB_STATIC_METHOD("Str$", "s", CVB_str, "(Value)v"),
  GB_STATIC_METHOD("Left", "s", CVB_Left, "(String)s(Count)i"),
  GB_STATIC_METHOD("Left$", "s", CVB_Left, "(String)s(Count)i"),
  GB_STATIC_METHOD("Right", "s", CVB_Right, "(String)s(Count)i"),
  GB_STATIC_METHOD("Right$", "s", CVB_Right, "(String)s(Count)i"),
  GB_STATIC_METHOD("Mid", "s", CVB_Mid, "(String)s(Start)i[(Count)i]"),
  GB_STATIC_METHOD("Mid$", "s", CVB_Mid, "(String)s(Start)i[(Count)i]"),
  //GB_METHOD("Dir", "s", CVB_dir, "(Mask)s[(Attributes)i]"),

  GB_END_DECLARE
};





